public class Monster {
  private int id;
  private String name = "Viech";
  private double lebenspunkte = 42;
  private float staerke = 41.41f;
  private int erfahrung = 100;
  private boolean istFriedlich = false;

  private static int counter = 1;  // Klassenvariable
  public static final int MAXSTAERKE = 100;
  private static final int BASIC = 42;
  
  public static void setzeCounter(int wert){ //Klassenmethode
    Monster.counter = wert;
  }
  
    /* parameterloser Konstruktor */
  public Monster(){
    this.id = Monster.counter;
    Monster.counter++;
  }

  public Monster(String name, double lebenspunkte, float staerke
  ,int erfahrung, boolean istFriedlich){
    super();
    this.name = name;
    this.lebenspunkte = lebenspunkte;
    this.staerke = staerke;
    this.erfahrung = erfahrung;
    this.istFriedlich = istFriedlich;        
  }
  
  public String toString() {
    return this.name + "(" + this.id + ") :" + this.lebenspunkte;
  }
  
  
  /* hat uebergebenes Monster gleichen Namen */
  public boolean hatGleichenNamenWie(Monster m){
    return this.name.equals(m.name);
    // if (this.name.equals(m.name)) { // hoelzern, aber korrekt
      // return true;
    // } else {
      // return false;
    // }
  }
  
  public boolean hatGleichenNamenWie2(Monster m){
    if (m == null){
      return false;
    }
    return this.name.equals(m.getName());
  }
  
  public int undOderSpielerei(){ // kein Kurzschluss, fuehrt zu Exception
    if (this.hatGleichenNamenWie2(null) & this.hatGleichenNamenWie(null)){
      return 41;
    }
    return Monster.BASIC;
  }
  
  public String getName(){
    return this.name; 
  }
  /* Schreiben Sie eine Methode die den Level eines 
   * Monsters ausgibt. Dabei ist der Level 1, wenn die
   * Stärke größer als 50 und die Erfahrung größer als
   * 100 ist, der Level ist 2, wenn nur eine der 
   * beiden Eigenschaften von Level 1 erfüllt ist und 
   * sonst Level 3.
   */
  int berechneLevel(){
    int ergebnis; 
    if(this.staerke > 50. && this.erfahrung > 100){
      ergebnis = 1;
    } else {
      if(this.staerke > 50. || this.erfahrung > 100){
        ergebnis = 2;
      } else {
        ergebnis = 3; 
      }
    }
    return ergebnis; 
  }

  int berechneLevel2(){
    if(this.staerke > 50. && this.erfahrung > 100){
      return 1;
    } else {
      if(this.staerke > 50. || this.erfahrung > 100){
        return 2;
      } else {
        return 3; 
      }
    } 
  }

  int berechneLevel3(){
    if(this.staerke > 50. && this.erfahrung > 100){
      return 1;
    }
    if(this.staerke > 50. || this.erfahrung > 100){
      return 2;
    }
    return 3; 
  }  

  int berechneLevelFragDoppel(){
    return (this.staerke > 50. && this.erfahrung > 100)? 1 : ((this.staerke > 50. || this.erfahrung > 100)? 2 : 3);
  }
  
  int berechneLevel4(){ // gruseligst
    EinUndAusgabe io = new EinUndAusgabe();
    int ergebnis; 
    if(this.staerke > 50. && this.erfahrung > 100){
      ergebnis = 1;
      io.ausgeben("Level ist eins");
    } else 
      if(this.staerke > 50. || this.erfahrung > 100) {
        ergebnis = 2;
        io.ausgeben("Level ist zwei");
      } else
        ergebnis = 3; 
        io.ausgeben("Level ist drei");
    return ergebnis; 
  }  
  /* Schreiben Sie eine Methode, die prüft ob das Monster
   * "Viech" heißt und dann den Nutzer auffordert den Namen
   * zu ändern und das nach einer Eingabe durchführt.
   * Heißt das Monster nicht "Viech", soll der Nutzer
   * mit einer Ausgabe informiert werden, dass der Name 
   * ok ist.
   */
  void nichtViechHeissen(){
    EinUndAusgabe io = new EinUndAusgabe();
    if(this.name.equals("Viech")){
      io.ausgeben("Aendere Namen: ");
      this.name = io.leseString();
    } else {
      io.ausgeben("Name ist schon ok.\n");
    }   
  }

  /* Schreiben Sie eine Methode, mit der String eingelesen
   * und der Name des Monsters auf den eingegebenen Text gesetzt wird.
   * Als Ergebnis soll eine Referenz auf das Monster zurückgegeben
   * werden.
   */
  Monster namenInteraktivAendern(){
    EinUndAusgabe io = new EinUndAusgabe(); 
    io.ausgeben("Neuer Name: ");  
    String neuerName = io.leseString(); // eingeben
    this.name = neuerName;
    return this; // zurückgeben
  }

  /* Schreiben Sie eine Methode, die einen double-Wert übergeben
   * bekommt und zurückgibt, ob das Monster stärker als dieser
   * Wert ist.
   */
  //Rueckgabetyp
  boolean       staerkerAls(double wert) {  // double-Wert uebergeben
    boolean ergebnis = this.staerke > wert;
    return ergebnis; // zurueckgeben
  }

  /* Schreiben Sie eine Methode, die die Lebenspunkte und die
   * Erfahrung jeweils um eins erhöht und diese Werte ausgibt.
   */
  void erhoehen(){  // nicht uebergeben
    this.lebenspunkte = this.lebenspunkte + 1;
    this.erfahrung = this.erfahrung + 1;
    EinUndAusgabe io = new EinUndAusgabe(); // ausgeben
    io.ausgeben(this.lebenspunkte + " : " + this.erfahrung); // ausgeben
  }


}