public class Klausurergebnis{
  private Studierend studi;
  private int punkte;
  
  public Klausurergebnis(Studierend studi, int punkte){
    this.punkte = punkte; 
    this.studi = studi;
  }
  
  public String note(){
    if (this.punkte >= 95){
      return "sehr gut";
    }
    if (this.punkte >= 80){
      return "gut";
    }
    if (this.punkte >= 65){
      return "befriedigend";
    }
    if (this.punkte >= 50){
      return "ausreichend";
    }    
    return "mangelhaft";
  }
  
  public String toString(){
    return "(" + this.studi + ": " + this.punkte + ")";
  }
  
  public Studierend getStudi(){
    return this.studi;
  }
  
  public int getPunkte(){
    return this.punkte;
  }
}
