
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class KlausurergebnisTest {
  
  private Klausurergebnis klgut;
  private Klausurergebnis klsehrgut;
  private EinUndAusgabe io = new EinUndAusgabe();
  
  @BeforeEach
  public void setUp(){
    this.klgut = new Klausurergebnis(new Studierend(), 83);
    this.klsehrgut = new Klausurergebnis(new Studierend(), 95);
    this.io.ausgeben("setUp\n");
  }
  
  @AfterEach
  public void tearDown(){
    this.io.ausgeben("tearDown\n");
  }

  @Test
  public void testNoteGut(){
    String wert = klgut.note();
    Assertions.assertEquals("gut", wert
      , "erwartet gut, gefunden " + wert);
    this.io.ausgeben("test1\n");  
  }
  
  @Test
  public void testNoteSehrGut(){
    Assertions.assertEquals("sehr gut", klsehrgut.note()
      , "erwartet sehr gut, gefunden " + klsehrgut.note());
    this.io.ausgeben("test2\n");  
  }
}
